﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
#Event: Selected(Value As Int)

#DesignerProperty: Key: BackGroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFB83DF1, Description: BackGround color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Dim BackGroundColor As Int
	Dim ChrMenu As List
	Dim Position As Int = 0
	Dim PanelHeight As Int = 80dip
	Dim ImageViewlSize As Int =60dip
	Dim LabelSize As Int = 40dip
	Dim BorderSize As Int = 20dip
	
	Dim SecondPanel As B4XView
	Dim Slct As B4XView
	
	Type BCEPixelGroup (SrcX As Int, SrcY As Int, x As Float, y As Float, dx As Float, dy As Float)
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	ChrMenu.Initialize
	
	#IF B4A OR B4I
	Slct=CreaImageView("Slct",ImageViewlSize,ImageViewlSize)
	#END IF
	SecondPanel=xui.CreatePanel("")
	SecondPanel.Color=xui.Color_White
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	BackGroundColor = xui.PaintOrColorToColor(Props.Get("BackGroundColor")) 
	
	mBase.SetLayoutAnimated(0,0,mBase.Parent.Height-PanelHeight,mBase.Parent.Width,PanelHeight)
	Invalidate
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mBase.SetLayoutAnimated(0,0,mBase.Parent.Height-PanelHeight,mBase.Parent.Width,PanelHeight)
	Invalidate
End Sub

Public Sub AddMenu(CharText As String, FontName As B4XFont)
	Dim M As Map
	
	M.Initialize
	M.Put("CharText",CharText)
	M.Put("Font",FontName)
	
	ChrMenu.Add(M)
	Invalidate
End Sub

Public Sub Clear
	ChrMenu.Clear
End Sub

Public Sub Invalidate
	Dim I As Int = 0
	Dim Label_Width As Float = mBase.Width / ChrMenu.Size
	Dim W As Int
	Dim ColoratedArea As Int = (ImageViewlSize-BorderSize)/2
	
	mBase.RemoveAllViews
	mBase.Color=BackGroundColor
	
	mBase.AddView(SecondPanel,0,ColoratedArea,mBase.Width,PanelHeight-ColoratedArea)
	SecondPanel.Color=xui.Color_White

	For Each M As Map In ChrMenu
		Dim L As Label
		L.Initialize("Label")
		Dim B4XL As B4XView = CreaLabel("Label",M.Get("CharText"),xui.Color_Gray,M.Get("Font"))
		B4XL.Tag=I
		W=(I+0.5)*Label_Width-(ImageViewlSize/2)
		mBase.AddView(B4XL,w,BorderSize,LabelSize,LabelSize)
		If I=Position Then
			#IF B4A OR B4I
			Slct.SetBitmap(GenerateBitmapSelected(M.Get("CharText"),xui.Color_Black,M.Get("Font")))
			#ELSE
			Slct=GenerateViewSelected(M.Get("CharText"),xui.Color_Black,M.Get("Font"))
			#END IF
			W=(Position+0.5)*Label_Width-((ImageViewlSize+BorderSize)/2)
			mBase.AddView(Slct,w,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
 		End If
		I=I+1
	Next
End Sub

Public Sub setBackGroundColor(C As Int)
	BackGroundColor = xui.PaintOrColorToColor(C) 
End Sub

#Region Event

#IF B4A OR B4I
Private Sub Label_Click
	Dim B4XL As B4XView = Sender
	Dim I As Int = B4XL.Tag
	Dim Label_Width As Float = mBase.Width / ChrMenu.Size
	Dim W As Int=(I+0.5)*Label_Width-((ImageViewlSize+BorderSize)/2)
	Dim M As Map = ChrMenu.Get(I)
	
	Position=I
	Slct.BringToFront
	Slct.SetBitmap(GenerateBitmapSelected("",xui.Color_Black,xui.CreateDefaultBoldFont(16)))
	Slct.SetLayoutAnimated(200,w,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
	Sleep(200)
	Animated(200,GenerateBitmapSelected(M.Get("CharText"),xui.Color_Black,M.Get("Font")),Slct)
	'TransitionAnimated(200,GenerateBitmapSelected("",xui.Color_Black,xui.CreateDefaultBoldFont(16)),GenerateBitmapSelected(M.Get("CharText"),xui.Color_Black,M.Get("Font")),Slct)
	
	If xui.SubExists(mCallBack,mEventName & "_Selected",1) Then CallSub2(mCallBack,mEventName & "_Selected",Position)
End Sub

#ELSE

Private Sub Label_MouseClicked (EventData As MouseEvent)
	Dim B4XL As B4XView = Sender
	Dim I As Int = B4XL.Tag
	Dim Label_Width As Float = mBase.Width / ChrMenu.Size
	Dim W As Int=(I+0.5)*Label_Width-((ImageViewlSize+BorderSize)/2)
	Dim M As Map = ChrMenu.Get(I)
	
	Position=I
	Slct.SetLayoutAnimated(200,w,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
	Sleep(200)
	Slct.RemoveAllViews
	Slct=GenerateViewSelected(M.Get("CharText"),xui.Color_Black,M.Get("Font"))
	mBase.AddView(Slct,w,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
	
	If xui.SubExists(mCallBack,mEventName & "_Selected",1) Then CallSub2(mCallBack,mEventName & "_Selected",Position)
End Sub
#END IF

Private Sub Slct_Click
	
End Sub

#End Region

#Region Grafic

#IF B4A OR B4I

Private Sub Animated (Duration As Int, Bmp As B4XBitmap, ImageView As B4XView) As ResumableSub 'ignore
	Dim source As BitmapCreator = CreateBC(Bmp)
	
	Dim NumberOfSteps As Int = Duration / 20
	Dim steps As Int = NumberOfSteps
	Dim GroupSize As Int = 6
	Dim w As Int = Bmp.Width / Bmp.Scale / GroupSize
	Dim h As Int = Bmp.Height / Bmp.Scale / GroupSize
	Dim pgs(w, h) As BCEPixelGroup
	Dim target As BitmapCreator
	target.Initialize(w * GroupSize, h * GroupSize)
	For x = 0 To w - 1
		For y = 0 To h - 1
			Dim pg As BCEPixelGroup = pgs(x, y)
			pg.SrcX = x * GroupSize
			pg.Srcy = y * GroupSize
			If (x>w*0.33 And x<w*0.66) And (y>h*0.20 And y<h*0.50) Then
				Select Rnd(0, 4)
					Case 0
						pg.x = target.mWidth*0.25
						pg.y = Rnd(target.mHeight*0.25, target.mHeight*0.75)
					Case 1
						pg.x = target.mWidth*0.75
						pg.y = Rnd(target.mHeight*0.25, target.mHeight*0.75)
					Case 2
						pg.x = Rnd(target.mWidth*0.25,target.mWidth*0.75)
						pg.y = target.mHeight*0.25
					Case 3
						pg.x = Rnd(target.mWidth*0.25,target.mWidth*0.75)
						pg.y = target.mHeight*0.75
				End Select
			Else
				pg.X = x * GroupSize
				pg.y = y * GroupSize
			End If
			
			pg.dx = (pg.SrcX - pg.x) / steps
			pg.dy = (pg.SrcY - pg.y) / steps
		Next
	Next
	Dim r As B4XRect
	r.Initialize(0, 0, 0, 0)
	For i = 0 To steps - 1
		target.FillRect(xui.Color_Transparent, target.TargetRect)
		For x = 0 To w - 1
			For y = 0 To h - 1
				Dim pg As BCEPixelGroup = pgs(x, y)
				pg.x = pg.x + pg.dx
				pg.y = pg.y + pg.dy
				r.Left = pg.SrcX
				r.Right = pg.SrcX + GroupSize
				r.Top = pg.SrcY
				r.Bottom = pg.SrcY + GroupSize
				target.DrawBitmapCreator(source, r, pg.x, pg.y, True)
			Next
		Next
		ImageView.SetBitmap(target.Bitmap)
		If xui.IsB4i Then
			Sleep(5)
		Else
			Sleep(16)
		End If
	Next
	ImageView.SetBitmap(Bmp)
	Return True
End Sub

Public Sub TransitionAnimated (Duration As Int, FromBmp As B4XBitmap, ToBmp As B4XBitmap, ImageView As B4XView) As ResumableSub
	Dim frombc As BitmapCreator = CreateBC(FromBmp)
	Dim tobc As BitmapCreator = CreateBC(ToBmp)
	Dim target As BitmapCreator
	target.Initialize(frombc.mWidth, frombc.mHeight)
	Dim StartTime As Long = DateTime.Now
	Dim EndTime As Long = StartTime + Duration
	Dim fromclr, toclr As ARGBColor
	Do While DateTime.Now < EndTime
		Dim progress As Float = (DateTime.Now - StartTime) / Duration
		For x = 0 To frombc.mWidth - 1
			For y = 0 To frombc.mHeight - 1
				frombc.GetARGB(x, y, fromclr)
				tobc.GetARGB(x, y, toclr)
				toclr.a = fromclr.a + progress * (toclr.a - fromclr.a)
				toclr.r = fromclr.r + progress * (toclr.r - fromclr.r)
				toclr.g = fromclr.g + progress * (toclr.g - fromclr.g)
				toclr.b = fromclr.b + progress * (toclr.b - fromclr.b)
				target.SetARGB(x, y, toclr)
			Next
		Next
		ImageView.SetBitmap(target.Bitmap)
		If xui.IsB4i Then 
			Sleep(5)
		Else
			Sleep(16)
		End If
	Loop
	ImageView.SetBitmap(target.Bitmap)
	Return True
End Sub

Private Sub GenerateBitmapSelected(Text As String, TextColor As Int,FontName As B4XFont) As B4XBitmap
	Dim PX As B4XView = xui.CreatePanel("") ' Main Panel
	Dim PX2 As B4XView = xui.CreatePanel("") ' Panel Hight Background
	Dim LX As B4XView = CreaLabel("",Text,TextColor,FontName) ' Label With text
	Dim SX As B4XView = CreaBall ' LEFT CIRCLE
	Dim DX As B4XView = CreaBall ' RIGHT CIRCLE
	
	PX.SetLayoutAnimated(0,0,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
	' Colorated area
	PX.AddView(PX2,0,0,ImageViewlSize+BorderSize,ImageViewlSize/2)
	PX2.Color=BackGroundColor
	'ball
	PX.AddView(SX,-BorderSize/2,(ImageViewlSize-BorderSize)/2,BorderSize,BorderSize)
	PX.AddView(DX,ImageViewlSize+BorderSize/2,(ImageViewlSize-BorderSize)/2,BorderSize,BorderSize)
	' text
	LX.TextSize=22
	PX.AddView(LX,BorderSize/2,0,ImageViewlSize,ImageViewlSize)
	LX.SetColorAndBorder(xui.Color_White,BorderSize*0.33,BackGroundColor,ImageViewlSize/2)
	
	#IF TEST 
		PX2.SetColorAndBorder(BackGroundColor,1dip,xui.Color_Black,0)
		PX.SetColorAndBorder(xui.Color_Transparent,1dip,xui.Color_Black,0)
	#END IF
	Return PX.Snapshot
End Sub

Private Sub CreaImageView(EventName As String,Width As Int, Height As Int) As B4XView 'ignore
	Dim Im As ImageView
	Im.Initialize(EventName)
	Dim V As B4XView= Im
	V.SetColorAndBorder(xui.Color_White,BorderSize/2,BackGroundColor,ImageViewlSize/2)
	
	Return V
End Sub

#ELSE

Private Sub GenerateViewSelected(Text As String, TextColor As Int,FontName As B4XFont) As B4XView
	Dim PX As B4XView = xui.CreatePanel("") ' Main Panel
	Dim PX2 As B4XView = xui.CreatePanel("") ' Panel Hight Background
	Dim LX As B4XView = CreaLabel("",Text,TextColor,FontName) ' Label With text
	Dim SX As B4XView = CreaBall ' LEFT CIRCLE
	Dim DX As B4XView = CreaBall ' RIGHT CIRCLE
	
	PX.SetLayoutAnimated(0,0,0,ImageViewlSize+BorderSize,ImageViewlSize+BorderSize)
	' Colorated area
	PX.AddView(PX2,0,0,ImageViewlSize+BorderSize,ImageViewlSize/2)
	PX2.Color=BackGroundColor
	'ball
	PX.AddView(SX,-BorderSize/2,(ImageViewlSize-BorderSize)/2,BorderSize,BorderSize)
	PX.AddView(DX,ImageViewlSize+BorderSize/2,(ImageViewlSize-BorderSize)/2,BorderSize,BorderSize)
	' text
	LX.TextSize=22
	PX.AddView(LX,BorderSize/2,0,ImageViewlSize,ImageViewlSize)
	LX.SetColorAndBorder(xui.Color_White,BorderSize*0.33,BackGroundColor,ImageViewlSize/2)
	
	#IF TEST 
		PX2.SetColorAndBorder(BackGroundColor,1dip,xui.Color_Black,0)
		PX.SetColorAndBorder(xui.Color_Transparent,1dip,xui.Color_Black,0)
	#END IF
	Return PX
End Sub
#END IF

Private Sub CreateBC(bmp As B4XBitmap) As BitmapCreator 'ignore
	Dim bc As BitmapCreator
	bc.Initialize(bmp.Width / bmp.Scale, bmp.Height / bmp.Scale)
	bc.CopyPixelsFromBitmap(bmp)
	Return bc
End Sub

Private Sub CreaLabel(EventName As String,Text As String, TextColor As Int, FontLabel As B4XFont) As B4XView
	Dim L As Label
	L.Initialize(EventName)
	
	Dim V As B4XView = L
	V.Text=Text
	V.TextColor=TextColor
	V.Font=FontLabel
	V.SetTextAlignment("CENTER","CENTER")
	
	Return V
End Sub

Private Sub CreaBall As B4XView
	Dim L As Label
	L.Initialize("")
	
	Dim V As B4XView = L
	V.SetLayoutAnimated(0,0,0,BorderSize,BorderSize)
	V.SetColorAndBorder(xui.Color_White,0,xui.Color_Black,BorderSize/2)
	
	Return V
End Sub

#End Region